import { Source } from '../../../../schema/domain';
import { MappingConfigService } from '../../../../schema/application';
import { DialectService, LanguagePort, DDLBuilderPort, DMLBuilderPort } from '../../../application';
export declare abstract class LanguageAdapter implements LanguagePort {
    dialects: DialectService[];
    name: string;
    solveComposite?: boolean;
    constructor(name: string, dialects: any);
    getDialect(name: string): DialectService;
    abstract ddlBuilder(source: Source, mapping: MappingConfigService): DDLBuilderPort;
    abstract dmlBuilder(source: Source, mapping: MappingConfigService): DMLBuilderPort;
}
