"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrmLibrary = void 0;
class OrmLibrary {
    // eslint-disable-next-line no-useless-constructor
    constructor(orm) {
        this.orm = orm;
    }
    load() {
        this.orm.expressions.addFunction('orm.execute(expression:string,data:any,options:any):any', (expression, data, options) => __awaiter(this, void 0, void 0, function* () {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return yield this.orm.execute(expression, data, options);
                // TODO: solve async execute
                // https://www.npmjs.com/package/glome-deasync
                // const execute = deasync((expression:string, data:any, options:any, done:any) => {
                // this.orm.execute(expression, data, options)
                // .then((result:any) => done(null, result))
                // .catch((error:any) => done(error))
                // })
                // const result = execute(expression, data, options)
                // return result
            }
        }));
        this.orm.expressions.addFunction('orm.plan(expression:string,options:any):any', (expression, options) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.plan(expression, options);
            }
        });
        this.orm.expressions.addFunction('orm.metadata(expression:string):any', (expression) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.metadata(expression);
            }
        });
        this.orm.expressions.addFunction('orm.model(expression:string):any', (expression) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.model(expression);
            }
        });
        this.orm.expressions.addFunction('orm.parameters(expression:string):any', (expression) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.parameters(expression);
            }
        });
        this.orm.expressions.addFunction('orm.constraints(expression:string):any', (expression) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.constraints(expression);
            }
        });
    }
}
exports.OrmLibrary = OrmLibrary;
//# sourceMappingURL=ormLibrary.js.map