import { Source } from '../../schema/domain';
import { OperandFacade } from '../../operand/application';
import { SchemaFacade, ViewConfigService } from '../../schema/application';
import { Metadata, MetadataConstraint, MetadataModel, MetadataParameter, Sentence, SentenceSerializer } from '../domain';
import { ICache } from 'h3lp';
import { Expressions } from '3xpr';
import { Helper } from '../../shared/application';
export declare class SentenceFacade {
    private readonly schemaFacade;
    private readonly operandFacade;
    private readonly expressions;
    private getConstraints;
    private builder;
    private builderComplete;
    private getMetadata;
    private getModel;
    private getParameters;
    private sentenceHelper;
    constructor(schemaFacade: SchemaFacade, operandFacade: OperandFacade, expressions: Expressions, cache: ICache<string, string>, serializer: SentenceSerializer, helper: Helper);
    build(expression: string, view: ViewConfigService, stage: string): Sentence;
    constraints(expression: string): MetadataConstraint;
    metadata(expression: string): Metadata;
    model(expression: string): MetadataModel[];
    parameters(expression: string): MetadataParameter[];
    getSource(sentence: Sentence, stage: string): Source;
}
